<?php

/* Color Box
-------------------------------------------------------------------------------------- */
class jQueryLightboxForNativeGalleries {
	// Plugin initialization
	function jQueryLightboxForNativeGalleries() {
		add_action( 'wp_head', array(&$this, 'wp_head') );
		add_filter( 'attachment_link', array(&$this, 'attachment_link'), 10, 2 );
	}
	function wp_head() {
	}
	// Make the thumbnails link to the fullsize image rather than a Page with the medium sized image
	function attachment_link( $link, $id ) {
		// The lightbox doesn't function inside feeds obviously, so don't modify anything
		if ( is_feed() )
			return $link;

		$post = get_post( $id );
		if ( 'image/' == substr( $post->post_mime_type, 0, 6 ) )
			return wp_get_attachment_url( $id );
		else
			return $link;
	}
}
add_action( 'init', 'jQueryLightboxForNativeGalleries', 7 );
function jQueryLightboxForNativeGalleries() {
	global $jQueryLightboxForNativeGalleries;
	$jQueryLightboxForNativeGalleries = new jQueryLightboxForNativeGalleries();
}

/* Widgetize
-------------------------------------------------------------------------------------- */
if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'before_widget' => '<li id="%1$s" class="widget %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h2 class="widgettitle">',
		'after_title' => '</h2>',
	));

/* Options Page
-------------------------------------------------------------------------------------- */
function italicsmile_options_page() {
	if ($_REQUEST['submit'])
		update_italicsmile_options(); ?>
		
	<div class="wrap">
		<h2>ItalicSmile ;) Options</h2>
		<?php print_italicsmile_form(); ?>
	</div>
	<?php
}
function update_italicsmile_options() {
	$updated = false;
	$error = false;
	
	if (isset($_REQUEST['italicsmile_search'])) {
		update_option('italicsmile_search', $_REQUEST['italicsmile_search']);
		$updated = true; }
		
	if ($_FILES['italicsmile_file_favicon']['name']) {
		$uploadedFile = italicsmile_upload_file($_FILES['italicsmile_file_favicon']);
		if (is_array($uploadedFile)) {
			$error = str_replace('*type*', 'Favicon', $uploadedFile[1]);
		} else {
			update_option('italicsmile_file_favicon', $uploadedFile);
			$updated = true;
		} }
	
	if ($updated) {
		echo '<div id="message" class="updated fade"><p>Options updated</p></div>';
		add_action('admin_menu','update_menu_items');
	} else {
		echo '<div id="message" class="error fade"><p>Unable to update options</p></div>';
	}
	
	if ($error)
		echo '<div id="message" class="updated fade"><p>'.$error.'</p></div>';
}
function print_italicsmile_form() {
	$italicsmile_search = get_option('italicsmile_search');
	$italicsmile_file_favicon = get_option('italicsmile_file_favicon');
	?>
	<form enctype="multipart/form-data" method="post">
		<h3>Change the default search box text</h3>
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><label for="italicsmile_search">Default search box text:</label></th>
				<td><input style="width:250px" type="text" name="italicsmile_search" value="<?php echo $italicsmile_search; ?>" /> Default Setting is "Search..."</td>
			</tr>
		</table>
		
		<h3>Upload a new favicon</h3>
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><label for="italicsmile_file_favicon">New Favicon:</label></th>
				<td><input style="width:200px" type="file" name="italicsmile_file_favicon" id="italicsmile_file_favicon" />
					<?php if ($italicsmile_file_favicon && file_exists(italicsmile_get_upload_dir().'/'.$italicsmile_file_favicon)) : ?> 
						<p><a href="?page=italicsmile&delete=<?php echo $italicsmile_file_favicon; ?>">Delete <?php echo $italicsmile_file_favicon; ?></a>
					<?php endif; ?> 
				</td>
			</tr>
		</table>
	
		<p class="submit"><input type="submit" name="submit" value="Save Changes" class="button-primary" />
		</p>
	
	</form>
	<?php
}
function italicsmile_add_pages() {
    add_options_page('ItalicSmile ;)', 'ItalicSmile ;)', 8, 'italicsmile', 'italicsmile_options_page');
}
add_action('admin_menu', 'italicsmile_add_pages');

if (!get_option('italicsmile_search')) {
	add_option('italicsmile_search','Search...');
}
if (!get_option('italicsmile_file_favicon')) {
	add_option('italicsmile_file_favicon','');
}

/* Options Support
-------------------------------------------------------------------------------------- */
function italicsmile_get_upload_dir($type='dir') {
	$wud = wp_upload_dir();
	if ('url' == $type)
		$italicsmile_ud = $wud['baseurl'] .'/italicsmile';
	else
		$italicsmile_ud = $wud['basedir'] .'/italicsmile';
	return $italicsmile_ud;
}
function italicsmile_upload_file($request_file) {
	// Get WP upload directory plug italicsmile directory within and create if it doesn't exist
	$italicsmile_ud = italicsmile_get_upload_dir();
	#$italicsmile_uu = $wud[baseurl] .'/italicsmile';
	if (!file_exists($italicsmile_ud))
		if (!mkdir($italicsmile_ud, 0777)) return array(false, "Cannot create ItalicSmile upload directory");
	
	// Process uploaded image file name
	$uploadFile = $request_file['name'];
	$uploadFileParts = explode('.', $uploadFile);
	$fileName = $uploadFileParts[0];
	$fileExt = strtolower(end($uploadFileParts));
	
	// Upload the file if it is an image
	if (italicsmile_isimage($fileExt)) {
		if ( move_uploaded_file($request_file['tmp_name'], $italicsmile_ud.'/'.$fileName.'.'.$fileExt) ) {
			return $fileName.'.'.$fileExt;
		} else {
			return array(false, "The file was not uploaded.");
		}
	} else {
		return array(false, "Unable to upload *type* file because it was not an image.");
	}
}
function italicsmile_delete_file($file) {
	// Get WP upload directory plus italicsmile directory within
	$italicsmile_ud = italicsmile_get_upload_dir();
	// Delete the file
	if (file_exists($italicsmile_ud.'/'.$file)) {
		unlink($italicsmile_ud.'/'.$file);
		echo "<div id=\"message\" class=\"updated fade\"><p>File ($file) deleted successfully.</p></div>";
	} else {
		echo "<div id=\"message\" class=\"updated fade\"><p>File ($file) does not appear to exist.</p></div>";
	}
	
	// Clean up. If a file does not exist, unset its option
	if (!is_file($italicsmile_ud.'/'.get_option('italicsmile_file_header')))
		update_option('italicsmile_file_header', '');
	elseif (!is_file($italicsmile_ud.'/'.get_option('italicsmile_file_footer')))
		update_option('italicsmile_file_footer', '');
	elseif (!is_file($italicsmile_ud.'/'.get_option('italicsmile_file_login')))
		update_option('italicsmile_file_login', '');
}
function italicsmile_isimage($ext) {
	return ('jpg' == $ext || 'jpeg' == $ext || 'gif' == $ext || 'png' == $ext || 'ico' == $ext) ? true : false;
}

/* Add a default-gravatar to options
-------------------------------------------------------------------------------------- */

if ( !function_exists('fb_addgravatar') ) {
	function fb_addgravatar( $avatar_defaults ) {
		$myavatar = get_bloginfo('template_directory') . '/images/italicavatar.gif';
		$avatar_defaults[$myavatar] = 'Italic Smile ;)';
 
		return $avatar_defaults;
	}
 
	add_filter( 'avatar_defaults', 'fb_addgravatar' );
}
?>